/*
  bike light control software,
  matti04.electronics, matti04.elecetronics@gmail.com
  tested on Arduino NANO
  20.07.2019
  used libaries:
  Adafruit NeoPixel

  more information: https://www.instructables.com/member/matti04_electronics/
*/

#include <Adafruit_NeoPixel.h>
Adafruit_NeoPixel ring = Adafruit_NeoPixel(14, 7, NEO_GRB + NEO_KHZ800);

void setup() {
  pinMode (4, INPUT); //drive detector
  pinMode (5, INPUT); //left
  pinMode (6, INPUT); //right

  pinMode (13, OUTPUT);

  ring.begin();
}

void loop() {
  while (digitalRead (4) == 1) {
    digitalWrite (13, LOW);
    if (digitalRead(5) == 1) {
      turnleft();
    }

    if (digitalRead(6) == 1) {
      turnright();
    }

    if (((digitalRead(5)) && (digitalRead (6))) == 0) {
      drive();
    }

  }

  animate();
}

void turnleft() {
  ring.setPixelColor (0, 255, 100, 0);
  ring.setPixelColor (7, 255, 100, 0);
  ring.show();
  delay (200);
  ring.setPixelColor (0, 0, 0, 0);
  ring.setPixelColor (7, 0, 0, 0);
  ring.show();
  ring.setPixelColor (1, 255, 100, 0);
  ring.setPixelColor (6, 255, 100, 0);
  ring.show();
  delay (200);
  ring.setPixelColor (1, 0, 0, 0);
  ring.setPixelColor (6, 0, 0, 0);
  ring.show();
  ring.setPixelColor (2, 255, 100, 0);
  ring.setPixelColor (5, 255, 100, 0);
  ring.show();
  delay (200);
  ring.setPixelColor (2, 0, 0, 0);
  ring.setPixelColor (5, 0, 0, 0);
  ring.show();
  ring.setPixelColor (3, 255, 100, 0);
  ring.setPixelColor (4, 255, 100, 0);
  ring.show();
  delay (200);
  ring.setPixelColor (3, 0, 0, 0);
  ring.setPixelColor (4, 0, 0, 0);
  ring.show();

  for (int i; i < 10; i = i + 1) {
    ring.setPixelColor (3, 255, 100, 0);
    ring.setPixelColor (4, 255, 100, 0);
    ring.show();
    delay (300);
    ring.setPixelColor (3, 0, 0, 0);
    ring.setPixelColor (4, 0, 0, 0);
    ring.show();
    delay (300);
  }
}

void turnright() {
  ring.setPixelColor (0, 255, 100, 0);
  ring.setPixelColor (7, 255, 100, 0);
  ring.show();
  delay (200);
  ring.setPixelColor (0, 0, 0, 0);
  ring.setPixelColor (7, 0, 0, 0);
  ring.show();
  ring.setPixelColor (13, 255, 100, 0);
  ring.setPixelColor (8, 255, 100, 0);
  ring.show();
  delay (200);
  ring.setPixelColor (13, 0, 0, 0);
  ring.setPixelColor (8, 0, 0, 0);
  ring.show();
  ring.setPixelColor (12, 255, 100, 0);
  ring.setPixelColor (9, 255, 100, 0);
  ring.show();
  delay (200);
  ring.setPixelColor (12, 0, 0, 0);
  ring.setPixelColor (9, 0, 0, 0);
  ring.show();
  ring.setPixelColor (11, 255, 100, 0);
  ring.setPixelColor (10, 255, 100, 0);
  ring.show();
  delay (200);
  ring.setPixelColor (11, 0, 0, 0);
  ring.setPixelColor (10, 0, 0, 0);
  ring.show();

  for (int i; i < 10; i = i + 1) {
    ring.setPixelColor (11, 255, 100, 0);
    ring.setPixelColor (10, 255, 100, 0);
    ring.show();
    delay (300);
    ring.setPixelColor (11, 0, 0, 0);
    ring.setPixelColor (10, 0, 0, 0);
    ring.show();
    delay (300);
  }
}

void drive() {
  ring.setPixelColor (2, 50, 0, 0);
  ring.setPixelColor (3, 50, 0, 0);
  ring.setPixelColor (4, 50, 0, 0);
  ring.setPixelColor (5, 50, 0, 0);

  ring.setPixelColor (9, 50, 0, 0);
  ring.setPixelColor (10, 50, 0, 0);
  ring.setPixelColor (11, 50, 0, 0);
  ring.setPixelColor (12, 50, 0, 0);
  ring.show();
}

void animate() {
  for (int pixel = 0; pixel < 18; pixel++) {
    ring.setPixelColor (pixel, 100, sq(pixel), pixel*20);
    ring.setPixelColor (pixel-1, 200, (sq(pixel))/2, (pixel*20)/2);
    ring.setPixelColor (pixel-2, 80, (sq(pixel))/3, (pixel*20)/3);
    ring.setPixelColor (pixel-3, 0, 0, 0);
    ring.show();
    delay (100);
  }
}